<template lang="pug">
form.form-horizontal
  div.divider.text-center(data-content="User Preferences")
  div.form-group
    div.col-3.col-sm-12
      label Interface color
    div.col-9.col-sm-12
      swatches(
        v-model="theme.primary"
        :colors="availableColors"
        background-color="rgba(var(--color-background), 1)"
        popover-to="right"
        shapes="circles"
        @input="$store.commit('theme/setPrimary', theme.primary)"
        inline
      )
</template>

<script>
import { mapGetters } from 'vuex'

import Swatches from 'vue-swatches'
import swatches from 'vue-swatches/src/presets/material-dark.js'
import 'vue-swatches/dist/vue-swatches.min.css'

export default {
  components: {
    Swatches
  },
  data() {
    return {
      theme: {
        primary: null
      },
      availableColors: [
        '#205e3b' // OLKi color
      ].concat(swatches.swatches)
    }
  },
  computed: {
    valid() {
      return !this.errors.any()
    }
  },
  mounted() {
    this.theme.primary = this.get().primary
  },
  methods: {
    ...mapGetters('theme', ['get']),
    next() {
      /**
       * next() is used in account/setup.vue to call the main action
       * of a component under its governance. It is mostly used to click
       * "save" while replacing the save button by its own.
       */
      // TODO
    }
  },
  $_veeValidate: {
    validator: 'new'
  }
}
</script>
